local packages = {}
local append = table.insert
local new = luajava.new
-- SciTE requires this, if you want to see stdout immediately...

io.stdout:setvbuf 'no'
io.stderr:setvbuf 'no'

local function massage_classname (classname)
  if classname:find('_') then
    classname = classname:gsub('_','$')
    end
  return classname
  end

local function import_class (classname,packagename)
  packagename = massage_classname(packagename)
  local res,class = pcall(luajava.bindClass,packagename)
  if res then
    _G[classname] = class    
    return class
    end
  end

local globalMT = {
__index = function(T,classname)
--  classname = massage_classname(classname)
  for i,p in ipairs(packages) do
    local class = import_class(classname,p..classname)
    if class then return class end
    end
  return nil
  end
}
setmetatable(_G, globalMT)

function import (package)
  local i = package:find('%*$')
  if i then -- a wildcard; put into the package list, including the final '.'
    append(packages,package:sub(1,-2))
    else
    local classname = package:match('([%w_]+)$')
    if not import_class(classname,package) then
      error("cannot find "..package)
      end
    end
  end

append(packages,'')

function proxy (classname,obj)
  classname = massage_classname(classname)
  -- if the classname contains dots it's assumed to be fully qualified
  if classname:find('.',1,true) then
    return luajava.createProxy(classname,obj)
    end
  -- otherwise, it must lie on the package path!
  for i,p in ipairs(packages) do
    local ok,res = pcall(luajava.createProxy,p..classname, obj)
    if ok then return res end
    end
  error ("cannot find "..classname)
  end


function enum(e)
  --local e = o:GetEnumerator()
  return function()
    if e:hasMoreElements() then
      return e:nextElement()
      end
    end
  end

function dump (t)
  local _t={}
  for k,v in pairs(t) do
    table.insert(_t,k.."="..tostring(v))
    end
  t=table.concat(_t,"\n")
  return t
  end

local function eval(k,v)
  local view = globalMT.__index(nil,k)(activity)
  for k,v in pairs(v) do
    if type(v)=="table" then
      view:addView(loadlayout(v))
      elseif k=="id" then
      rawset(_G,v,view)
      else
      view["set"..k](view,v)
      end
    end
  return view
  end
function loadlayout(activity,t)
  for k,v in pairs(t) do
    return eval(k,v)
    end
  end

import 'java.lang.*'
import 'java.util.*'

