-- Author: Dige
-- Time:2019/10/25
--[[
    requirements:
    lua-cjson
    luasocket
]] --

-- local requireLib = function()
-- 	-- 先加载android的
-- 	local loadAnroidLib = function()
-- 		local http = nil
-- 		local zlib = nil
-- 		http = require("http")
-- 		zlib = require("zlib")
-- 		http.TIMEOUT = 8
-- 		return http,zlib
-- 	end
-- 	local is_ture,http,zlib = pcall(loadAnroidLib)

-- 	-- 失败加载ios的
-- 	if not is_ture then
-- 		http = require("socket.http")
-- 		zlib = require("zlib")
-- 	end
-- 	return http,zlib
-- end

-- -- 最后失败，加载通用的
-- local is_true,http,zlib = pcall(requireLib)
-- if not is_true then
-- 	https = require("ssl.https")
-- end


local ltn12 = require('ltn12')
local json = require('cjson')
 --

--[[公共函数]] function get_ms_time()
    local current_time = os.time()
    local _, s = math.modf(current_time / 100)
    math.randomseed(s * 100 * 3 * 7 * 11 * 13)
    local rand_time = math.random(100, 1000)
    return tonumber(tostring(current_time) .. rand_time)
end

--构造返回格式
function format_return(data, msg, code, report)
    local result = {}
    code = code == nil and 900 or code
    report = report == nil and '' or report
    result['code'] = code
    result['update_time'] = os.time()
    result['data'] = data
    result['msg'] = msg
    return result
end

--编码url
function encode_uri(s)
    s =
        string.gsub(
        s,
        '([^%w%.%- _])',
        function(c)
            return string.format('%%%02X', string.byte(c))
        end
    )
    return string.gsub(s, ' ', '+')
end

-- 合并两个table,把table2合并到table1中
function table_merge(table1, table2)
    for i, v in pairs(table2) do
        table1[i] = v
    end
    return table1
end

-- 通过请求地址,参数数组，获取完整的get url
function get_query_string(host, params)
    local str = '?'
    for i, v in pairs(params) do
        str = str .. i .. '=' .. encodeURI(v) .. '&'
    end
    return host .. string.sub(str, 1, -2)
end

--访问网页获取内容
function capture(u, h, site_type, ...)
	local https = require('ssl.https')
    local arg = {...}
    local rels = {}
    local s = ltn12.sink.table(rels)

    local code = 200
    local response_header = ''
    local status = ''

    --print("------request start-----")
    --print(u)
    --print(json.encode(h))
    --print("------request end  -----")
    _, code, response_header, status = https.request({url = u, sink = s, headers = h, red})

    --print("------rsponse start-----")
    --print(code)
    --print(json.encode(response_header))
    --print(json.encode(rels))
    --print("------rsponse end  -----")

    local result = {}

    -- 请求没有头部返回
    if response_header == nil then
        return format_return(u, tostring(code), 500)
    end

    -- 请求返回，但不是code=200
    if tonumber(code) ~= 200 then
        return format_return(u, tostring(status), code)
    end

    -- 请求返回，但没有结果
    if next(rels) == nil or rels[1] == nil then
        return format_return(u, 'NO CONTENT', 204)
    end

    local response_data = ''
    for i, v in pairs(rels) do
        response_data = response_data .. v
    end

    if response_header['content-encoding'] == 'gzip' then
        local inflated, eof, bytes_in, bytes_out = zlib.inflate()(response_data)
        response_data = inflated
    end

    -- 根据情况返回结果
    local rel = response_data
    result = format_return(rel, 'OK', 200)

    return result, response_data
end
 --

--[[业务函数]] function get_content(host, params, header)
    local default_header = {}

    if zlib ~= nil then
        default_header['Accept-Encoding'] = 'gzip'
    end

    local url = get_query_string(host, params)
    default_header = table_merge(default_header, header)

    local is_true, rel, response
    is_true, rel, response = pcall(capture, url, default_header, '', params['callback'])

    if not is_true then
        rel = format_return(url .. ' ' .. json.encode(default_header), tostring(rel))
    end
    return rel, response, url
end

function filter_404(result)
    if result.data == '{"locationId":null}' then
        result['code'] = 404
        result['msg'] = 'NOT FOUND'
        result['data'] = ''
    end
    return json.encode(result)
end

function get_player_info_by_tag(tag)
    result, response, __ = get_content(string.format('https://api.clashofstats.com/players/%s', tag), {}, {})
    return filter_404(result)
end

function get_clan_info_by_tag(tag)
    result, response, __ = get_content(string.format('https://api.clashofstats.com/clans/%s', tag), {}, {})
    return filter_404(result)
end

function get_clan_members_by_tag(tag)
    result, response, __ = get_content(string.format('https://api.clashofstats.com/clans/%s/members', tag), {}, {})
    return filter_404(result)
end

function get_clan_rankings_by_tag(tag)
    result, response, __ = get_content(string.format('https://api.clashofstats.com/clans/%s/rankings', tag), {}, {})
    return filter_404(result)
end

function get_random_ua()
    ua_table = {
		'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; BLA-AL00 Build/HUAWEIBLA-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.9 Mobile Safari/537.36',
		'Mozilla/5.0 (Linux; Android 8.1; PAR-AL00 Build/HUAWEIPAR-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.132 MQQBrowser/6.2 TBS/044304 Mobile Safari/537.36 MicroMessenger/6.7.3.1360(0x26070333) NetType/WIFI Language/zh_CN Process/tools',
		'Mozilla/5.0 (Linux; Android 8.1.0; ALP-AL00 Build/HUAWEIALP-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/10.13 baiduboxapp/10.13.0.11 (Baidu; P1 8.1.0)',
		'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MHA-AL00 Build/HUAWEIMHA-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/40.0.2214.89 UCBrowser/11.6.4.950 UWS/2.11.1.50 Mobile Safari/537.36 AliApp(DingTalk/4.5.8) com.alibaba.android.rimet/10380049 Channel/227200 language/zh-CN',
		'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; BLA-AL00 Build/HUAWEIBLA-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/11.9.4.974 UWS/2.13.1.48 Mobile Safari/537.36 AliApp(DingTalk/4.5.11) com.alibaba.android.rimet/10487439 Channel/227200 language/zh-CN',
		'Mozilla/5.0 (Linux; Android 5.1.1; vivo X6S A Build/LMY47V; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.132 MQQBrowser/6.2 TBS/044207 Mobile Safari/537.36 MicroMessenger/6.7.3.1340(0x26070332) NetType/4G Language/zh_CN Process/tools',
		'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; BLA-AL00 Build/HUAWEIBLA-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.9 Mobile Safari/537.36',
		'Mozilla/5.0 (iPhone; CPU iPhone OS 13_0 like Mac OS X) AppleWebKit/602.1.38 (KHTML, like Gecko) Version/10.0 Mobile/14A41DS1497c Safari/602.1',
		'Mozilla/5.0 (iPod; CPU iPhone OS 12_0 like macOS) AppleWebKit/602.1.50 (KHTML, like Gecko) Version/12.0 Mobile/14A5335d Safari/602.1.50'
	}
	return ua_table[math.random(#ua_table)]
end


function get_packed_http_request_parts(player_tag, clan_tag)
	data = {}
	if player_tag ~= 'NULL' then
		get_player_info_by_tag = {}
		get_player_info_by_tag['method'] = 'GET'
		get_player_info_by_tag['url'] = string.format('https://api.clashofstats.com/players/%s', player_tag)
		get_player_info_by_tag['request_headers'] = nil
		get_player_info_by_tag['request_body'] = nil
		data['get_player_info_by_tag'] = get_player_info_by_tag
	end

	if clan_tag ~= 'NULL' then
		get_clan_info_by_tag = {}
		get_clan_info_by_tag['method'] = 'GET'
		get_clan_info_by_tag['url'] = string.format('https://api.clashofstats.com/clans/%s', clan_tag)
		get_clan_info_by_tag['request_headers'] = nil
		get_clan_info_by_tag['request_body'] = nil

		get_clan_members_by_tag = {}
		get_clan_members_by_tag['method'] = 'GET'
		get_clan_members_by_tag['url'] = string.format('https://api.clashofstats.com/clans/%s/members', clan_tag)
		get_clan_members_by_tag['request_headers'] = nil
		get_clan_members_by_tag['request_body'] = nil

		get_clan_rankings_by_tag = {}
		get_clan_rankings_by_tag['method'] = 'GET'
		get_clan_rankings_by_tag['url'] = string.format('https://api.clashofstats.com/clans/%s/rankings', clan_tag)
		get_clan_rankings_by_tag['request_headers'] = nil
		get_clan_rankings_by_tag['request_body'] = nil

		data['get_clan_info_by_tag'] = get_clan_info_by_tag
		data['get_clan_members_by_tag'] = get_clan_members_by_tag
		data['get_clan_rankings_by_tag'] = get_clan_rankings_by_tag
	end
    return json.encode(format_return(data, 'OK', 200))
end

print(get_player_info_by_tag('#28CP982R9'))
-- print(get_packed_http_request_parts('28CP982R9'))
